(function() {
    /* device ready */
    document.addEventListener('deviceready', function () {
        FastClick.attach(document.body);

        if (navigator.notification) { // Override default HTML alert with native dialog
            window.alert = function (message) {
                navigator.notification.alert(
                    message,    // message
                    null,       // callback
                    "Bra Size Calculator", // title
                    'OK'        // buttonName
                );
            };
        }

        if( window.plugins && window.plugins.AdMob ) {
            var adId = 'ca-app-pub-6200067808955905/7787205249';
            var am = window.plugins.AdMob;

            am.createBannerView( 
                {
                'publisherId': adId,
                'adSize': am.AD_SIZE.SMART_BANNER,
                'bannerAtTop': false
                }, 
                function() {
                    am.requestAd(
                        { 'isTesting':false }, 
                        function(){
                            am.showAd( true );
                        }, 
                        function(){ alert('failed to request ad'); }
                    );
                }, 
                function(){ alert('failed to create banner view'); }
            );
        } else {
          alert('AdMob plugin not available/ready.');
        }
        
        if (navigator.app) {
            document.addEventListener("backbutton", function(evt) {
                var hash = window.location.hash;
                if (hash === '#measurements0' || hash === '' || hash === '#') {
                    evt.preventDefault();
                    navigator.app.exitApp();
                }
                else {
                    navigator.app.backHistory()
                }
            }, false);
        }

    }, false);
        /* fix topcoat buttons to work with toggle radio buttons */
        var ButtonBarButtons = document.getElementsByClassName('topcoat-button-bar__button');
        for (var bbb=0; bbb<ButtonBarButtons.length; bbb++) {
            ButtonBarButtons[bbb].addEventListener('click', function() {
                this.parentNode.getElementsByTagName('input')[0].checked = true;
                if ("createEvent" in document) {
                    var changeEvent = document.createEvent('HTMLEvents');
                    changeEvent.initEvent("change", false, true);
                    this.parentNode.getElementsByTagName('input')[0].dispatchEvent(changeEvent);
                } else {
                    this.parentNode.getElementsByTagName('input')[0].fireEvent("onchange");
                }
            }, false);
        }








    /* ---------- MEASUREMENTS ---------- */

    /* get html elements */
    var unitElements = document.getElementsByName('unit');
    var overbustElement = document.getElementById('w-biuscie');
    var underbustElement = document.getElementById('pod-biustem');


    /* set values for html elements */
    if (localStorage.getItem('overbust') !== null) {
        overbustElement.value = localStorage.getItem('overbust');
    }
    if (localStorage.getItem('underbust') !== null) {
        underbustElement.value = localStorage.getItem('underbust');
    }
    if (localStorage.getItem('cmin') !== null) {
        applyUnit(localStorage.getItem('cmin'));
    } else {
        applyUnit('cm');
    }


    /* add event listeners */
    unitElements[0].addEventListener('change', function() {
        applyUnit(this.value);
    }, false);
    unitElements[1].addEventListener('change', function() {
        applyUnit(this.value);
    }, false);

    overbustElement.addEventListener('change', function() {
        localStorage.setItem('overbust', overbustElement.value);
    }, false);
    underbustElement.addEventListener('change', function() {
        localStorage.setItem('underbust', underbustElement.value);
    }, false);

    document.getElementById('zatwierdz').addEventListener('click', function(evt) {
        evt.preventDefault();
        if (!(parseFloat(overbustElement.value) % parseFloat(overbustElement.step) === 0 && (parseFloat(underbustElement.value) % parseFloat(underbustElement.step) === 0))) {
            if (parseFloat(overbustElement.step) === 0.5) {
                overbustElement.value = (Math.round(parseFloat(overbustElement.value) * 2)) / 2;
                underbustElement.value = (Math.round(parseFloat(underbustElement.value) * 2)) / 2;
            }
            else {
                overbustElement.value = Math.round(overbustElement.value);
                underbustElement.value = Math.round(underbustElement.value);
            }
        }
        var validateAlert = '';
        if (!(parseFloat(overbustElement.value) >= parseFloat(overbustElement.min))) {
            validateAlert += 'Overbust minimum value is ' + overbustElement.min + ' ' + localStorage.getItem('cmin') + '\n';
        }
        if (!(parseFloat(overbustElement.value) <= parseFloat(overbustElement.max))) {
            validateAlert += 'Overbust maximum value is ' + overbustElement.max + ' ' + localStorage.getItem('cmin') + '\n';
        }
        if (!(parseFloat(underbustElement.value) >= parseFloat(underbustElement.min))) {
            validateAlert += 'Underbust minimum value is ' + underbustElement.min + ' ' + localStorage.getItem('cmin') + '\n';
        }
        if (!(parseFloat(underbustElement.value) <= parseFloat(underbustElement.max))) {
            validateAlert += 'Underbust maximum value is ' + underbustElement.max + ' ' + localStorage.getItem('cmin') + '\n';
        }
        if (parseFloat(underbustElement.value) >= parseFloat(overbustElement.value)) {
            validateAlert += 'Overbust value must be greater than underbust value\n';
        }
        if (validateAlert !== '') {
            alert(validateAlert);
            return false;
        }
        window.location.hash = '#size0';
        localStorage.setItem('overbust', overbustElement.value);
        localStorage.setItem('underbust', underbustElement.value);
        sizeFunction();
    }, false);


    /* functions */
    function applyUnit(cmin) {
        if (localStorage.getItem('cmin') != cmin) {
            localStorage.setItem('cmin', cmin);
            var change = true;
        } else {
            var change = false;
        }
        if (cmin === 'in') {
            unitElements[1].checked = true;
            
            if (change) {
                overbustElement.value = ((overbustElement.value / 2.54 * 2).toFixed()) / 2;
                underbustElement.value = ((underbustElement.value / 2.54 * 2).toFixed()) / 2;
            }
            
            overbustElement.min = 27;
            overbustElement.max = 69.5;
            underbustElement.min = 23.5;
            underbustElement.max = 51;
            underbustElement.setAttribute('step', 0.5);
            overbustElement.setAttribute('step', 0.5);
        } else {
            unitElements[0].checked = true;
            
            if (change) {
                overbustElement.value = (overbustElement.value * 2.54).toFixed();
                underbustElement.value = (underbustElement.value * 2.54).toFixed();
            }
            
            overbustElement.min = 69;
            overbustElement.max = 177;
            underbustElement.min = 60;
            underbustElement.max = 130;
            underbustElement.setAttribute('step', 1);
            overbustElement.setAttribute('step', 1);
        }
        localStorage.setItem('overbust', overbustElement.value);
        localStorage.setItem('underbust', underbustElement.value);
    }

    






    /* ---------- ROUTING ---------- */

    var measurements = document.getElementById('measurements');
    var size = document.getElementById('size');
    var about = document.getElementById('about');

    window.addEventListener('hashchange', route, false);
    window.addEventListener('load', route, false);
    function route() {
        var hash = window.location.hash;
        if (hash === '#measurements0' || hash === '' || hash === '#') {
            measurements.className = 'p-0';
            size.className = 'p-xp1';
        } else if (hash === '#size0') {
            measurements.className = 'p-xm1';
            size.className = 'p-0';
        }

        if (hash === '#about0') {
            about.className = 'p-0';
        } else {
            about.className = 'p-ym1';
        }
    }








    /* ---------- BRA SIZE ---------- */

    /* cup sizes arrays */
    var cupsArrayUK = ['AA', 'A', 'B', 'C', 'D', 'DD', 'E', 'F', 'FF', 'G', 'GG', 'H', 'HH', 'J', 'JJ', 'K', 'KK', 'L', 'LL', 'M', 'MM', 'N'];
    var cupsArrayUS = ['AA', 'A', 'B', 'C', 'D', 'DD/E', 'DDD/F', 'DDDD/G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U'];
    var cupsArrayEU = ['AA', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
    var cupsArrayIT = ['AA', 'A', 'B', 'C', 'DD', 'D', 'E', 'F', 'G', 'H', 'II', 'I', 'JJ', 'J', 'KK', 'K'];
    var romanNumeralsArray = ['I', 'II', 'III', 'IV', 'V', 'VI', 'VII', 'VIII', 'IX', 'X', 'XI', 'XII', 'XIII', 'XIV', 'XV', 'XVI', 'XVII', 'XVIII', 'XIX', 'XX'];

    /* get html elements */
    var fittingStandardElements = document.getElementsByName('fitting-standard');
    var calculatedElement = document.getElementById('calculated');
    var adjustedElement = document.getElementById('adjusted');

    /* set values for elements */
    /* add event listeners */
    var fittingStandard = localStorage.getItem('fittingStandard') || 'EU';
    for (var fse = 0; fse<fittingStandardElements.length; fse++) {
        if (fittingStandardElements[fse].value === fittingStandard) {
            fittingStandardElements[fse].checked = true;
        }
        fittingStandardElements[fse].addEventListener('change', function() {
            var fittingStandard = this.value;
            localStorage.setItem('fittingStandard', fittingStandard);
            showFunction(fittingStandard);
        }, false);
    }

    document.getElementById('pomiary').addEventListener('click', function(evt) {
        evt.preventDefault();
        window.location.hash = '#measurements0';
    }, false);

    document.getElementById('too-loose').addEventListener('click', function(evt) {
        var adjustedSizes = JSON.parse(sessionStorage.getItem('adjustedSizes'));
        adjustedSizes.bandEU -= 5;
        adjustedSizes.bandUK -= 2;
        adjustedSizes.differenceEU += 2;
        adjustedSizes.differenceUK += 2;
        sessionStorage.setItem('adjustedSizes', JSON.stringify(adjustedSizes));
        showFunction();
    }, false);
    document.getElementById('too-tight').addEventListener('click', function(evt) {
        var adjustedSizes = JSON.parse(sessionStorage.getItem('adjustedSizes'));
        adjustedSizes.bandEU  += 5;
        adjustedSizes.bandUK += 2;
        adjustedSizes.differenceEU -= 2;
        adjustedSizes.differenceUK -=2;
        sessionStorage.setItem('adjustedSizes', JSON.stringify(adjustedSizes));
        showFunction();
    }, false);
    document.getElementById('too-big').addEventListener('click', function(evt) {
        var adjustedSizes = JSON.parse(sessionStorage.getItem('adjustedSizes'));
        adjustedSizes.bandEU += 0;
        adjustedSizes.bandUK += 0;
        adjustedSizes.differenceEU -= 1;
        adjustedSizes.differenceUK -= 1;
        sessionStorage.setItem('adjustedSizes', JSON.stringify(adjustedSizes));
        showFunction();
    }, false);
    document.getElementById('too-small').addEventListener('click', function(evt) {
        var adjustedSizes = JSON.parse(sessionStorage.getItem('adjustedSizes'));
        adjustedSizes.bandEU += 0;
        adjustedSizes.bandUK += 0;
        adjustedSizes.differenceEU += 1;
        adjustedSizes.differenceUK += 1;
        sessionStorage.setItem('adjustedSizes', JSON.stringify(adjustedSizes));
        showFunction();
    }, false);
    document.getElementById('reset').addEventListener('click', function() {
        sessionStorage.setItem('adjustedSizes', sessionStorage.getItem('calculatedSizes'));
        showFunction();
    }, false);

    /* functions */
    function sizeFunction () {
        if (!localStorage.getItem('fittingStandard')) {
            localStorage.setItem('fittingStandard', 'EU');
        }
        var calculatedSizes = calculateFunction();
        sessionStorage.setItem('calculatedSizes', JSON.stringify(calculatedSizes));
        sessionStorage.setItem('adjustedSizes', JSON.stringify(calculatedSizes));
        showFunction();
    }
    function calculateFunction() {
        var overbust = +(localStorage.getItem('overbust'));
        var underbust = +(localStorage.getItem('underbust'));
        var jednostka = localStorage.getItem('cmin');
        if (jednostka === 'in') {
            var overbustIn = (Math.round(overbust * 2)) / 2;
            var underbustIn = (Math.round(underbust * 2)) / 2;
            var overbustCm = Math.round(overbust*2.54);
            var underbustCm = Math.round(underbust*2.54);
        } else {
            var overbustIn = (Math.round(overbust / 2.54 * 2)) / 2;
            var underbustIn = (Math.round(underbust / 2.54 * 2)) / 2;
            var overbustCm = Math.round(overbust);
            var underbustCm = Math.round(underbust);
        }

        if (jednostka === 'in') {
            var bandUK = underbustIn;
            bandUK -= (((underbustIn/5 - 12/2.54) + 4/2.54) - ((underbustIn/5 - 12/2.54)*0.2));
            bandUK = Math.floor(bandUK);
            if (bandUK%2 !== 0) {
                bandUK += 5;
            } else {
                bandUK += 4;
            }
            var bandEU = Math.round((bandUK-4)*2.54/10*2)/2*10;
        } else {
            var bandEU = underbustCm;
            bandEU -= (((underbustCm/5 - 12) + 4) - ((underbustCm/5 - 12)*0.2));
            bandEU = (Math.round(bandEU / 10 * 2)) / 2 * 10;
            var bandUK = Math.ceil(bandEU/2.54)+4;
        }


        var differenceUK = overbustIn - bandUK;
        if (differenceUK < 0 && differenceUK >= -1) {
            differenceUK = 0;
        } else {
            differenceUK = Math.floor(differenceUK + 1);
        }

        var differenceEU = overbustCm - bandEU;
        if (differenceEU < 12 && differenceEU >= 10) {
            differenceEU = 0;
        } else {
            differenceEU = Math.round((differenceEU - 11) / 2);
        }

        return {'bandEU': bandEU, 'bandUK': bandUK, 'differenceEU': differenceEU, 'differenceUK': differenceUK};
    }

 
    function showFunction(standard) {
        var calculatedSizes = JSON.parse(sessionStorage.getItem('calculatedSizes'));
        var adjustedSizes = JSON.parse(sessionStorage.getItem('adjustedSizes'));
        if (standard) {
            var standard = standard;
            calculatedElement.className = 'scaleY0';
            adjustedElement.className = 'scaleY0';
        } else {
            var standard = localStorage.getItem('fittingStandard');
            adjustedElement.className = 'scaleX0';
        }

        var resultCalculated, resultAdjusted;
        if (standard === 'EU') {
            resultCalculated = '<span class="additional">(' + calculatedSizes.bandUK.toString() + ')</span> ' + calculatedSizes.bandEU.toString() + cupsArrayEU[calculatedSizes.differenceEU];
            resultAdjusted = '<span class="additional">(' + adjustedSizes.bandUK.toString() + ')</span> ' + adjustedSizes.bandEU.toString() + cupsArrayEU[adjustedSizes.differenceEU];
        } else if (standard === 'UK') {
            resultCalculated = '<span class="additional">(' + calculatedSizes.bandEU.toString() + ')</span> ' + calculatedSizes.bandUK.toString() + cupsArrayUK[calculatedSizes.differenceUK];
            resultAdjusted = '<span class="additional">(' + adjustedSizes.bandEU.toString() + ')</span> ' + adjustedSizes.bandUK.toString() + cupsArrayUK[adjustedSizes.differenceUK];
        } else if (standard === 'US') {
            resultCalculated = calculatedSizes.bandUK.toString() + cupsArrayUS[calculatedSizes.differenceUK];
            resultAdjusted = adjustedSizes.bandUK.toString() + cupsArrayUS[adjustedSizes.differenceUK];
        } else if (standard === 'AU') {
            resultCalculated = (calculatedSizes.bandUK - 22).toString() + cupsArrayUK[calculatedSizes.differenceUK];
            resultAdjusted = (adjustedSizes.bandUK - 22).toString() + cupsArrayUK[adjustedSizes.differenceUK];
        } else if (standard === 'FR') {
            resultCalculated = (calculatedSizes.bandEU + 15).toString() + cupsArrayEU[calculatedSizes.differenceEU];
            resultAdjusted = (adjustedSizes.bandEU + 15).toString() + cupsArrayEU[adjustedSizes.differenceEU];
        } else if (standard === 'IT') {
            if (((calculatedSizes.bandEU / 5 - 12) > 0) && ((calculatedSizes.bandEU / 5 - 12) <= 20)) {
                resultCalculated = romanNumeralsArray[(calculatedSizes.bandEU / 5 - 12) - 1] + ' ' + cupsArrayIT[calculatedSizes.differenceUK - 1];
            } else {
                resultCalculated = (calculatedSizes.bandEU / 5 - 12).toString() + ' ' + cupsArrayIT[calculatedSizes.differenceUK - 1];
            }
            if (((adjustedSizes.bandEU / 5 - 12) > 0) && ((adjustedSizes.bandEU / 5 - 12) <= 20)) {
                resultAdjusted = romanNumeralsArray[(adjustedSizes.bandEU / 5 - 12) - 1] + ' ' + cupsArrayIT[adjustedSizes.differenceUK - 1];
            } else {
                resultAdjusted = (adjustedSizes.bandEU / 5 - 12).toString() + ' ' + cupsArrayIT[adjustedSizes.differenceUK - 1];
            }
        }

        setTimeout(function() {
            calculatedElement.innerHTML = resultCalculated.replace(/undefined/g, ' -');
            adjustedElement.innerHTML= resultAdjusted.replace(/undefined/g, ' -');
            calculatedElement.className = '';
            adjustedElement.className = '';
        }, 100);
    }








    /* ---------- ABOUT ---------- */

    document.getElementById('informacje').addEventListener('click', function(evt) {
        evt.preventDefault();
        if (window.location.hash != '#about0') {
            window.location.hash = '#about0';
        }
        else {
            window.history.go(-1);
        }
    }, false);

    document.getElementById('wstecz').addEventListener('click', function(evt) {
        evt.preventDefault();
        window.history.go(-1);
    }, false);

})();
